import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import javax.swing.border.*;
import java.net.URL;

//Creacin del frame y de sus componentes
public class vcframe extends JFrame implements ListSelectionListener{
  JPanel contentPane;//Panel principal del frame
  JPanel Pane2 = new JPanel();//Panel secunadario que alberga labels
  JMenuBar jMenuBar1 = new JMenuBar();//barra de mens
  JMenu jMenuFile = new JMenu(); //menu archivo
  JMenuItem jMenuFileExit = new JMenuItem();//opcion salir del men archivo
  JMenuItem jMenuAbreArchivo = new JMenuItem();//opcion agregar un video de men arhivo
  JMenuItem jMenuQuitaArchivo = new JMenuItem();//opcion quitar video de men arhivo
  JMenuItem jMenuGuardaArchivo = new JMenuItem();//opcion guardar cambios de men arhivo
  JMenu jMenuHelp = new JMenu();//menu de ayuda
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JFileChooser ventanaarch = new JFileChooser();//file chooser  muestra el cuadro de dialogo para elegir un archivo
  Border border1;
  JLabel jLabel1 = new JLabel();//Labels para desplegar texto en pantalla
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();//Scroll panel donde se desplegar la lista
  JList jList2;//Objeto que desplega la lista de videos en pantalla
  DefaultListModel duracion;//Lista de las duraciones de los videos
  DefaultListModel paths;//Lista para las rutas de acceso de los videos
  DefaultListModel nombres;//Lista para los nombres de los videos
  ListSelectionModel lsm;//modelo de seleccion para la lista jList2
  String nombre;//nombre del archivo de videos
  JOptionPane cuadroduracion =new JOptionPane();//cuadro de dialogo para ingresar la duracin
  JOptionPane cuadrocerrar =new JOptionPane();//cuadro de dialogo para guardar cambios al cerrar
  GridBagLayout gridbag=new GridBagLayout();//Layout para el frame
  GridBagConstraints c=new GridBagConstraints();
  int total;//total de videos en la lista
  int nframes;//numero de frames que crea la aplicacion al principio
  boolean cambios=false;//indica si hay cambios que guardar

  /**Mtodo Constructor del frame principal*/
  public vcframe(DefaultListModel Lista,DefaultListModel Lista2,DefaultListModel Lista3,int total,String nombre) {
    this.nombre=nombre;//asigna el nombre del archivo de videos a su propia variable nombre
    nombres=Lista;//asigna la lista recibida al objeto nombres
    // y se crea una lista desplegable a partir del modelo de lista nombres
    jList2=new JList(nombres);
    duracion=Lista2;//asigna la lista de duraciones recibida al objeto duracion
    paths=Lista3;//asigna la lista de rutas de acceso recibida al objeto paths
    this.total=total;//asigna el total de videos a la variable total
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();//metodo de inicializacion de componentes
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /*Inicializacion de componentes*/
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();//Asigna a contentpane el panel del frame actual
    border1 = new EtchedBorder(EtchedBorder.RAISED,new Color(255, 255, 235),new Color(135, 133, 115));
    contentPane.setLayout(gridbag);//Se fija el Layout Manager para el frame
    Pane2.setLayout(new FlowLayout()); //layout para Pane2
    this.setSize(new Dimension(400, 350));//tamao de la ventana
    this.setTitle("Programa de administracion de videos");//titulo de la ventana
    //ttulos de los mens
    jMenuFile.setText("Archivo");
    jMenuQuitaArchivo.setText("Eliminar Video");
    jMenuAbreArchivo.setText("Agregar Video");
    jMenuFileExit.setText("Salir");
    jMenuGuardaArchivo.setText("Guardar Cambios");
    jMenuHelp.setText("Ayuda");
    jMenuHelpAbout.setText("Documentacion");

    //detalles de despliegue de los componentes
    jList2.setFont(new java.awt.Font("SansSerif", 1, 14));
    jList2.setBorder(BorderFactory.createLoweredBevelBorder());
    contentPane.setFont(new java.awt.Font("SansSerif", 1, 12));
    contentPane.setForeground(Color.white);
    contentPane.setBorder(border1);
    contentPane.setToolTipText("");
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 12));
    jLabel1.setForeground(Color.darkGray);
    jLabel1.setText("Lista de videos ");
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 12));
    jLabel2.setForeground(Color.blue);
    jLabel2.setText("Duracin ");
    jLabel3.setFont(new java.awt.Font("SansSerif", 1, 12));
    jLabel3.setForeground(Color.blue);
    jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jScrollPane1.setSize(new Dimension(250, 176));
    //se agregan los itemes de menu a los mens principales
    jMenuFile.add(jMenuFileExit);
    jMenuFile.add(jMenuAbreArchivo);
    jMenuFile.add(jMenuQuitaArchivo);
    jMenuFile.add(jMenuGuardaArchivo);
    jMenuHelp.add(jMenuHelpAbout);
     //se agregan los menus principales a la barra de men
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    //Se agregan los elementos al panel del frame
    //el objeto c contiene las restricciones del Layout
    //estas restricciones se actualizan para cada objeto
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridx =0;
    c.gridy=0;
    c.weightx = 1;
    c.weighty=0.1;
    c.anchor=GridBagConstraints.SOUTH;
    contentPane.add(jLabel1,c);
    //se agregan los labels al panel respectivo
    Pane2.add(jLabel2, null);//Pane 2 se encarga de desplegar la duracion de los videos
    Pane2.add(jLabel3, null);
    c.gridx = 0;
    c.gridy=1;
    c.weighty=0.9;
    c.fill=GridBagConstraints.BOTH;
    jScrollPane1.getViewport().add(jList2, null);//se agrega jList 2 a scrollPane1 para hacer una lista con barras de desplazamiento
    contentPane.add(jScrollPane1,c );
    c.gridx =1;
    c.gridy=1;
    contentPane.add(Pane2,c);
    //se definen los mtodos que atendern las acciones de los mens
    jMenuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });

    jMenuAbreArchivo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuAbreArchivo_actionPerformed(e);
      }
    });

    jMenuQuitaArchivo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuQuitaArchivo_actionPerformed(e);
      }
    });

    jMenuGuardaArchivo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuGuardaArchivo_actionPerformed(e);
      }
    });

    jMenuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuHelpAbout_actionPerformed(e);
      }
    });

    //seteos iniciales
    try{
    jList2.setSelectedIndex(0);
    jLabel3.setText(duracion.getElementAt(0) + "  min");
    }catch (ArrayIndexOutOfBoundsException b){}
    Pane2.setVisible(true);
    this.setJMenuBar(jMenuBar1);//se agrega la barra de mens
    lsm=jList2.getSelectionModel();
    //se agrega el manejador de eventos de seleccion de la lista
    //en este caso, el mismo vcframe maneja los eventos
    lsm.addListSelectionListener(this);
    nframes=this.getFrames().length;//numero de frames que se crean en un principio
  }
   //A continuacin, se especifican los mtodos que se utilizan al producirse distintos eventos
  /**Archivo | salir action performed*/
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    //si se han hecho cambios se pregunta si se desea guardarlos mediante un cuadro de dialogo(cuadrocerrar)
    if(cambios){
    int retorno=cuadrocerrar.showConfirmDialog(this,"Desea guardar los cambios?","Cerrar",JOptionPane.YES_NO_OPTION);
    if (retorno==JOptionPane.YES_OPTION){
      jMenuGuardaArchivo_actionPerformed(null);
   //si se elige guardar, se llama al mismo metodo que si se elige guardar desde el men
    }

    }
    System.exit(0);//luego, se sale
  }
  /**Ayuda | Documentacion action performed*/
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
  int i=this.getFrames().length;
  if(i==nframes){
  //Crea un frame para mostrar la documentacin
  frameayuda ayuda=new frameayuda();
  ayuda.setVisible(true);
  }
  else{
    this.getFrames()[2].setVisible(true);
  }
  }

  //mtodo para cerrar el programa desde el boton cerrar de la ventana
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      //se llama al mismo mtodo que cuando se cierra desde el men
      jMenuFileExit_actionPerformed(null);
    }
  }

//mtodo para manejar los cambios de seleccion de la lista
public void valueChanged(ListSelectionEvent e){
int i;
i=jList2.getSelectedIndex();//se obtiene el indice del video seleccionado
jLabel3.setText(duracion.getElementAt(i)+"  min"); //se muestra la duracion de ese video
}

//mtodo que permite agregar un nuevo video a la lista, activado por el comando del menu
void jMenuAbreArchivo_actionPerformed(ActionEvent e) {
File Archvideos;
jMenuAbreArchivo.setSelected(false);
jMenuFile.setPopupMenuVisible(false);
int retorno = ventanaarch.showOpenDialog(jMenuFile);//se muestra la ventana de dialogo para elegir un archivo
if (retorno==JFileChooser.APPROVE_OPTION){//si elige un archivo
    Archvideos=ventanaarch.getSelectedFile();//se obtiene el archivo elegido
    paths.addElement(Archvideos.getPath());//Se agrega el path a la lista paths
    nombres.addElement(Archvideos.getName());//se agrega el nombre a la lista nombres
    //se abre otro cuadro de dialogo para ingresar la duracion
    //el retorno del cuadro de dialogo se agrega a la lista duracion
    duracion.addElement(cuadroduracion.showInputDialog(this,"Ingrese duracin (en minutos)"));
    //se deja el archivo agregado como seleccionado
    if (total==0){
	jLabel3.setText(duracion.getElementAt(0)+" min");
	}
    jList2.setSelectedIndex(total);
    total++;//se incrementa el nmero de videos
    cambios=true;//se han producido cambios
  }


  }
//mtodo que permite quitar un archivo de la lista

void jMenuQuitaArchivo_actionPerformed(ActionEvent e) {
cambios=true;
int i=jList2.getSelectedIndex();//obtiene el indice del archivo seleccionado
//quita el elemento con ese indice de todas las listas
nombres.removeElementAt(i);
paths.removeElementAt(i);
duracion.removeElementAt(i);
//deja seleccionado el primer indice
try{
jList2.setSelectedIndex(0);
}catch (ArrayIndexOutOfBoundsException c){
jLabel3.setText(" ");
}
total--;

  }

//mtodo para guardar el archivo de videos modificado
void jMenuGuardaArchivo_actionPerformed(ActionEvent e) {

try{
//se crea un escritor para el archivo especificado por nombre
BufferedWriter bw=new BufferedWriter(new FileWriter(nombre));
 //se escribe lnea por lnea el archivo
for(int i=0;i<total;i++){
  bw.write((i+1)+"^"+nombres.getElementAt(i)+"^"+duracion.getElementAt(i)+"^"+paths.getElementAt(i));
  bw.newLine();
  }
bw.close();
}catch(IOException e2){};
cambios=false;//los cambios ya fueron guardados
}
}

